searchNodes=[{"doc":"Element for forwarding buffers to at least one output pad It has one input pad :input and 2 output pads: :master - is a static pad which is always available and works in pull mode :copy - is a dynamic pad that can be linked to any number of elements (including 0) and works in push mode The :master pad dictates the speed of processing data and any element (or elements) connected to :copy pad will receive the same data as :master Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :copy Availability :on_request Caps :any Direction :output Mode :push Name :copy :master Availability :always Caps :any Direction :output Mode :pull Name :master","ref":"Membrane.Tee.Master.html","title":"Membrane.Tee.Master","type":"module"},{"doc":"Returns pads descriptions for Membrane.Tee.Master","ref":"Membrane.Tee.Master.html#membrane_pads/0","title":"Membrane.Tee.Master.membrane_pads/0","type":"function"},{"doc":"Element for forwarding packets to multiple outputs. The processing speed is limited by the slowest consuming output. To use, link this element to one preceding element via input pad and multiple succesive elements via output pads. Each buffer is forwarded only when demand for it comes in via each output. Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :on_request Caps :any Direction :output Mode :pull Name :output","ref":"Membrane.Tee.Parallel.html","title":"Membrane.Tee.Parallel","type":"module"},{"doc":"Returns pads descriptions for Membrane.Tee.Parallel","ref":"Membrane.Tee.Parallel.html#membrane_pads/0","title":"Membrane.Tee.Parallel.membrane_pads/0","type":"function"},{"doc":"This package provides elements that can be used to branch stream processing in pipeline, e.g. send data from one source to two or more sinks.","ref":"readme.html","title":"Membrane Tee Plugin","type":"extras"},{"doc":"This package can be installed by adding membrane_tee_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_tee_plugin , &quot;~&gt; 0.7.0&quot; } ] end The docs can be found at HexDocs .","ref":"readme.html#installation","title":"Membrane Tee Plugin - Installation","type":"extras"},{"doc":"Membrane.Tee.Parallel This element has dynamic :output pads working in :pull mode. Packets are forwarded only when all output pads send demands, which means that the slowest output pad dictates the speed of processing data. Playing this pipeline should result in copying the source file to all destination files (sinks). Before playing it, make sure that the source file exists, e.g. like this: echo &quot;Membrane Framework is cool&quot; &gt; /tmp/source_text_file You also need :membrane_file_plugin in project dependencies to run this pipeline. defmodule FileMultiForwardPipeline do use Membrane.Pipeline alias Membrane . { File , Tee } @impl true def handle_init ( _ ) do children = [ file_src : % File.Source { location : &quot;/tmp/source_text_file&quot; } , tee : Tee.Parallel , file_sink1 : % File.Sink { location : &quot;/tmp/destination_file1&quot; } , file_sink2 : % File.Sink { location : &quot;/tmp/destination_file2&quot; } , ] links = [ link ( :file_src ) |&gt; to ( :tee ) |&gt; to ( :file_sink1 ) , link ( :tee ) |&gt; to ( :file_sink2 ) ] { { :ok , % ParentSpec { children : children , links : links } } , %{ } } end end Membrane.Tee.Master This element has one :master output pad that dictates the speed of processing data and dynamic :copy pad working in :push mode mirroring :master pad. Playing this pipeline should result in playing mp3 source file and copying it to the destination file. Before playing it, make sure you have valid source file, e.g. this one . You also need :membrane_file_plugin and :membrane_portaudio_plugin in project dependencies to run this pipeline. defmodule AudioPlayAndCopyPipeline do use Membrane.Pipeline alias Membrane . { File , Tee , PortAudio } @impl true def handle_init ( _ ) do children = [ file_src : % File.Source { location : &quot;/tmp/source_file.mp3&quot; } , tee : Tee.Master , audio_sink : PortAudio.Sink , file_sink : % File.Sink { location : &quot;/tmp/destination_file.mp3&quot; } , ] links = [ link ( :file_src ) |&gt; to ( :tee ) , link ( :tee ) |&gt; via_out ( :master ) |&gt; to ( :audio_sink ) , link ( :tee ) |&gt; via_out ( :copy ) |&gt; to ( :file_sink ) ] { { :ok , % ParentSpec { children : children , links : links } } , %{ } } end end","ref":"readme.html#examples","title":"Membrane Tee Plugin - Examples","type":"extras"},{"doc":"Copyright 2019, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane Tee Plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]